package main

import (
	"acme-client/src"
	"bufio"
	"log"
	"os"
	"strings"
)

func main() {
	validConf()
	// 获取指令, 如果没有则提示添加
	args := os.Args
	if len(args) < 2 {
		log.Println("请输入命令; 如: add")
		log.Println("或者输入 help 查看帮助")
		return
	}
	src.OnCommand()
}

func validConf() {
	// 读取server参数,如果没有提示添加
	config := src.GetClientConfig()
	server := config.Server
	if server == "" {
		log.Println("请输入服务端地址; 如: http://acme.server.com:8080")
		reader := bufio.NewReader(os.Stdin)
		serverAddr, err := reader.ReadString('\n')
		if err != nil {
			log.Fatal(err)
		}
		serverAddr = strings.Trim(serverAddr, "\r\n")
		config.Server = serverAddr
		src.WriteConfig()
	}

	// 读取服务器RSA公钥, 没有提示添加
	rsaPublicKey := config.RsaPublicKey
	if rsaPublicKey == "" {
		log.Println("请输入服务端下发的RAS公钥;")
		reader := bufio.NewReader(os.Stdin)
		rsaPublicKeyContent, err := reader.ReadString('\n')
		if err != nil {
			log.Fatal(err)
		}
		rsaPublicKeyContent = strings.Trim(rsaPublicKeyContent, "\r\n")
		config.RsaPublicKey = rsaPublicKeyContent
		src.WriteConfig()
	}
}
