package src

import (
	"encoding/json"
	"errors"
	"io"
	"net/http"
)

// http get
func httpGet(url string, token string) (string, error) {
	resp, err := http.Get(url)
	if err != nil {
		return "", err
	}
	defer resp.Body.Close()
	body, err := io.ReadAll(resp.Body)
	if err != nil {
		return "", err
	}
	result := Result{}
	err = json.Unmarshal(body, &result)
	if err != nil {
		return "", err
	}
	if result.Code != 200 {
		return "", errors.New(result.Msg)
	}
	data := result.Data
	return DecryptByToken(token, data), nil
}
