package src

import (
	"acme-client/src/crypto"
	"crypto/rand"
	"encoding/base64"
	"encoding/hex"
	"log"
	"math/big"
)

const charset = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789"

func randomStr(length int) string {
	b := make([]byte, length)
	for i := range b {
		randomIndex, _ := rand.Int(rand.Reader, big.NewInt(int64(len(charset))))
		b[i] = charset[randomIndex.Int64()]
	}
	return string(b)
}

func GenToken() (token string, encryptToken string) {
	token = randomStr(32)
	key := GetClientConfig().RsaPublicKey

	tokenBytes, err := crypto.EncryptRSABase64(key, []byte(token))
	if err != nil {
		log.Fatal("Error encrypting data:", err)
	}
	encryptToken = hex.EncodeToString(tokenBytes)

	return
}

func DecryptByToken(token string, data string) string {
	content, err := base64.StdEncoding.DecodeString(data)
	if err != nil {
		log.Fatal("Error decoding data:", err)
	}
	res := crypto.DecryptAES([]byte(token), content)
	return string(res)
}
